#if !defined(_ADATA_INTWAIT_H)
#define _ADATA_INTWAIT_H

#include "platform.h"
#include "device.h"
#include "ioctls.h"

extern void
ADMXRC_FpgaInterrupt(
  DeviceContext* pDevCtx,
  unsigned int index);

extern OS_STATUS
ADMXRC_WaitForInterrupt(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq,
  ADMXRC_IOCTLS_WAITFORINTERRUPT* pIoctl,
  unsigned long inSize,
  unsigned long outSize);

extern OS_STATUS
ADMXRC_CancelWaitForInterrupt(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq);

extern OS_STATUS
ADMXRC_RegInterruptEvent(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq,
  ADMXRC_IOCTLS_REGINTERRUPTEVENT* pIoctl,
  unsigned long inSize);

extern OS_STATUS
ADMXRC_UnregInterruptEvent(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq,
  ADMXRC_IOCTLS_UNREGINTERRUPTEVENT* pIoctl,
  unsigned long inSize);

extern void 
ADMXRC_UnregAllInterruptEvents(
  DeviceContext* pDevCtx);

#endif
